\documentclass[a4paper,11pt]{article}

\usepackage{amsmath,amssymb}
\usepackage{fullpage}
\usepackage{hyperref}
\usepackage{graphicx}
\usepackage{tikz}
\usepackage{caption}
\usepackage[labelformat=simple]{subcaption}
\renewcommand\thesubfigure{(\alph{subfigure})}

\newcommand{\RR}{\mathbb{R}}

\newcommand{\dpl}{\left\langle}
\newcommand{\dpm}{,}
\newcommand{\dpr}{\right\rangle}
\newcommand{\dotprod}[2]{\dpl #1 \dpm #2 \dpr}


\title{Network Enrichment Analysis}
\author{Cheng Soon Ong, Ilana Lichtenstein}


\begin{document}
\maketitle
\begin{abstract}
  This is a collection of ideas for enrichment analysis of the graph
  where the edges are SNP pairs from GWIS.
\end{abstract}



\section{Network Enrichment}

\subsection{Motivation}

We assume that some efficient filters have been run on whole genome data, resulting in SNP pairs. By considering the pairs as edges in a graph, we can explore the pairwise associations at a higher level by
considering the resulting network.

\subsection{Sources of edges}
\begin{description}
\item[Hypothesis testing]\ \\
  These are the pairs of SNPs strongly associated with disease.
\item[Genotype correlation]\ \\
  By taking the inner product between each pair of SNPs, we can
  discover highly correlated pairs. This is in similar in spirit to
  linkage disequilibrium.\\
  \begin{footnotesize}
    \url{http://dx.doi.org/10.1006/geno.1995.9003}
  \end{footnotesize}
\item[Measures of Correlation]
  There are different ways to measure correlation such as inner product, covariance, Pearson and Spearman correlation and linkage disequilibrium (LD). 
  These all essentially measure the frequency with which the major allele ('A1') from the first SNP co-occurs with major allele ('B1') from the second SNP, and similarly, the frequency with which the minor allele ('A2') co-occurs with minor allele ('B2'). 
 LD calculations are designed for haplotypes rather than genotypes. That is, the function is based on the frequency of e.g. A1B1 assuming only one copy of the allele in an individual. When we are dealing with genotypes for a diploid organism such as humans, there are two copies of each allele. The commonly used encoding for the genotype at each snp is 2: two copies of the major allele, 1: 1 copy of the major allele, and 0: zero copies of the major allele. 
A high correlation between 2 snps therefore means, that in both copies of the two alleles (allele-pair), the first major allele (A1) co-occurs frequently with the second major allele (A2), and the minor allele (A2) co-occurs with the second minor allele (B2).  i.e. we see many instances (individuals) carrying genotypes (2-2) and (0-0).
However, we cannot calculate a haplotype table uniquely from the genotype. Due to 'ambiguous' gametic phase, we do not know the frequency of the co-occurence of the two major alleles from two genotypes that are both heterozygous (1-1). For example, if we count 4 instances of 1-1 for an allele pair, it is possible that the gametic phase has resolved this as: A1B1, A2B2 (*4), or A1B2, A2B1 (*4), or some other combination of allele pairing. 
We can therefore estimate the value $D_{hat}$ when calculating LD with genotypes, but taking the mean of these values to be our estimate of the number of instances of A1B1 co-occurences in the same (e.g. 4/2 =2). Alternatively, plink has more sophisticated methods of estimating haplotype of 2 snps by using an EM algorithm that considers neighbouring pairs. See:
http://pngu.mgh.harvard.edu/~purcell/plink/ld.shtml
  
r2 provides a good measure of correlation. 


\item[Motivation]
  If two snps are located close to one-another on a chromosome, and have a high correlation, we might guess that each snp could individually give a strong score, and that a bivariate analysis is not required.  In the case where they dont have a high gwis score (i.e) simply appear connected to a mutual 3rd snp in a subgraph, the two snps can be merged. 

\item[Correlation vs GWIS]

If they do have a high gwis score, this can be of interest. In particular, it depends on the snp-pair genotypes that are used to distinguish case and controls in gwis. If the pair includes N00,N11 or N22, then it is possible that the snps are in LD. This is because even though this haplotype is interesting, if we know the value of the first snp pair, then we know the value of the second snp pair (e.g, an A1 always pairs with B1, and A2 always pairs with B2). Hence these snps should be detected with a univariate test. 
When the pairing is N11, if we assume phasing is such that the major allele pairs with major allele, then this also can be assumed to be in LD. (Such pairs should be checked in plink). 

On the other hand, if the gWIS separating pairs are N10, N01,then we cannot tell the identity of the second allele from the first. Ie, for N01: A2 may pair with B1 or B2. Therefore, the individuals of interest do not show LD-ness for these snps and perhaps we should not merge them in a subgraph. In fact, these snps may be particularly interesting if they belong to the same gene (hence their nearness).  

In particular, for breast cancer, there are no high r2 values for gwis pairs.

This is the case for some bipolar snps that appear on the diagonal in the r2 heatmap. 



Some examples:
Draw  contingency tables of 10;0;10;0 separating to 10;0;0;0 and 0;0;0;10 - giving good correlation and good GWIS, but it is the same snp 
There are instances where this is not true, however. For example, there may be a genotype where there is good correlation and good GWIS(above) but it is because a small number of e.g. A1B2=5 separate between case and control well. 
So, after this step, we have to further divide those GWIS graphs with good correlation into those where there is still a genotype of interest, and those where there is no genotype of interest. 


TO DO: We need to examine the colourings that come out of GWIS to see whether they belong to N22 or N11 or N00 etc. for gWIS pairs in wtccc bd that are close and have high r2.
TO DO: Merge snps in subgraphs where bivariate graph shows hub connected to close genes. Currently, they merge based on bp distance, but we can use r2 values to help with this merge. 



\item[Genomic location]\ \\
  Due to linkage disequilibrium, SNPs which are near each other along
  the chromosome tend to be inherited together. By computing the
  distance in base pairs, we can compare this to the genotype
  correlation above and discover ``nearby'' SNPs.


To access chromosome and base pair location information for each probe we match the Affymetrix ID to each snp rs identifier via a file location in UCSC hg19 database. 

For WTCCC data the table identifier is SnpArrayAffy250Nsp.txt.gz and SnpArrayAffy250Sty.txt.gz. We found this table through the Genome Browser, Variations track and selected SNP/CNV and viewed the table schema to find the name of the Primary Table. We then went to the home page, and clicked on the Downloads tab, and selected human annotation database to search for the flat file.

For breast cancer data, we downloaded the SNP137Common table which contains snp ids mapping to genomic locations in the current hg19 build, according to dbSnp build 137. We filtered to only export single nucleotide variations in the output.  To get rid of duplicate copies:
head -6473 SNP137Common\_bc571\_DSS\_top4000.bed

\subsection{Gene Identification}


To access chromosome and base pair location information for each probe we match the Affymetrix ID to each snp rs identifier via a file location in UCSC hg19 database. The table identifier is SnpArrayAffy250Nsp.txt.gz and SnpArrayAffy250Sty.txt.gz. 

\item[Gene Annotation Sources]
We also downloaded gene annotation files and refFlat file from this UCSC table browser in bed format. We can use bedtools or python wrapper (pybedtools) to intersect genomic locations from GWIS snps with the annotated bed files. 

To identify the gene itself, it is possible to use RefSeq genes (in refFlat file), GenBank genes or Encode Transcripts identified in the file wgEncodeGencodeCompv12 (around 30,000 genes). 

Also, HGNC can be used as a reference. The HGNC group has compiled a list of all genes with annotations from multiple databases.

\item[Snp-Gene Association]
To identify a gene for each snp, the dbSnp website recommends looking 2000bp 5\' and 500bp 3\' of the gene start and stop site for a snp.  However, we looked 100000 bp of the gene in either direction for a snp. We recorded the top 3 genes that were closest to the snp in either direction. We record the direction as a sign (ie + means, snp is location upstream from the gene, - means snp is located downstream from the gene). 

We used bedtools function intersect and window to find genes. For intersect, we use option '-wa','-wb'.
For window, we used the option '-sw'.
From bedtools:
Especially when dealing with gene annotations or RNA-seq experiments, you may want to define asymmetric windows based on “strand”. For example, you may want to screen for overlaps that occur within 5000 bp upstream of a gene (e.g. a promoter region) while screening only 1000 bp downstream of the gene. By enabling the -sw (“stranded” windows) option, the windows are added upstream or downstream according to strand. For example, imagine one specifies -l 5000, -r 1000 as well as the -sw option. In this case, forward stranded (“+”) features will screen 5000 bp to the left (that is, lower genomic coordinates) and 1000 bp to the right (that is, higher genomic coordinates). By contrast, reverse stranded (“-”) features will screen 5000 bp to the right (that is, higher genomic coordinates) and 1000 bp to the left (that is, lower genomic coordinates).'


\end{description}

\subsection{Gene Set Enrichment Analysis}
\begin{description}
\item[Gene Set Enrichment Analysis]

\item[Gene Set Pair Enrichment Analysis]
We look for gene-gene pairs where both genes are in the set. Some rules exist, given each snp is mapped to up to 3 genes, and sorted by bp\_distance (near to far). If we take only the closest gene, the following rules apply:

\begin{itemize}
\item We create a single pair entry for each snp-snp pair, using the closest gene. 
\item If either snp does not map to a gene, no pair is added to the list.
\end{itemize}

If we look at all genes mapped to the snp, the following rules apply.
\begin{itemize}
\item We create a pair entry for each possible combination of gene-gene mappings. For example, if there are 3 unique genes mapped to each snp that is 3*3=9 pairs added to the list.  
\item For each snp-snp pair, if the same gene is recorded twice, it means the gene has multiple exon starts. We include this gene as a pair with each of the other genes only once. 
\end{itemize}


When converting to a dictionary, we then count the number of unique rows for each gene-gene pair. This entry is the number of snp-snp pairs mapping to this unique gene-gene 
pair. 

The Wilcoxon rank sum test does not provide particularly useful results. The method searches for genes in the set that are near the top and the bottom of the list. However, this is not really appropriate where we only have ranks for the top genes. For example, the lowest p-value belongs to a gene set, where there is one gene pair overlap, that appears at the bottom of the ranked list of pairs. 

\end{description}
\subsection{Multilabel Graph Partitioning}
\begin{description}
\item[Connected subgraphs]
  Finding the connected subgraphs can be done using breadth first
  search and colouring each component. The adjacency matrix and the
  Laplacian decompose into blocks corresponding to the components.\\
  \begin{footnotesize}
    Kincaid and Philips ``Network topology measures'', 2011
  \end{footnotesize}
\item[Clustering links]\ \\
  Clustering links to allow multilabel vertices
  \begin{footnotesize}
    \begin{itemize}
    \item \url{http://www.nature.com/nature/journal/v466/n7307/pdf/nature09182.pdf}
    \item \url{http://pre.aps.org/pdf/PRE/v80/i1/e016105}
    \item \url{http://www.cs.utexas.edu/users/inderjit/public_papers/multilevel_pami.pdf}
    \item \url{http://www.cs.berkeley.edu/~stefje/papers/NIPS-2007-Luxburg.pdf}
    \end{itemize}
  \end{footnotesize}
\end{description}

\subsection{Subgraph Analysis}

\begin{description}
\item[Univariate association] \ \\
  Subgraphs which only contain SNPs that are near each other are not
  really ``interacting'' mutations. It is highly likely that the pairs
  are due to the same causal mutation.
\item[Parallel association] \ \\
  Subgraphs which are similar to bipartite graphs, where there two
  sets of SNPs each from a genomic location, indicate two associated
  mutations. This reflects strong evidence of pairwise association, as
  the effect is strong enough to be detected multiple times.
\item[Mutual Exclusivity]
Some subgraphs have a hub appearance where one snp is connected to multiple snps. This suggests the possibility that this snp is required in combination with another snp, but that the second snp is different in different "sets" of individuals. One option is to run GWIS using 3-way gWIS on subgraphs of interest. We are looking now for genotypes in the bottom of the ROC curve, with poor predictive ability. E.g. if AABbCc separates poorly but AABb and AACc separate well, does this suggest mutual exclusivity? (show picture of ROC curve and table of 2-way and 3-way genotypes for case and control)
\item[Gene/Pathway enrichment] \ \\
  By doing graph matching with known knowledge bases of interaction
  pathways, we can discover potential causes of disease.
  \begin{footnotesize}
    \begin{itemize}
    \item \url{http://bree.cs.nott.ac.uk/enrichnet/index.php}
    \item \url{http://www.string-db.org/}
    \item \url{http://wiki.c2b2.columbia.edu/honiglab_public/index.php/Software:PrePPI}
    \item \url{http://www.nature.com/nmeth/journal/v8/n6/pdf/nmeth.1597.pdf}
    \item \url{http://www.sciencemag.org/content/322/5898/104.full.pdf}
    \end{itemize}
  \end{footnotesize}

\item[Data Sources]
There are many potential interaction databases. They vary according to number of interactions, source of interactions (e.g. PubMed), and the type of interaction networks covered (e.g.human signaling or metabolic networks). 

There are also many different file formats available including XML-based formats such as KGML (KEGG), BioPax (Reactome) and GPML (KEGG pathways available through PathVisio) and MI-PSI. Wikipathways allows you to download pathways by species in various formats including flat files, Biopax. Pathway Commons allows you to download by source or by species. The tab-delimited format allows you to download by source, with species specified for each node in a separate tab-delimited format. The source databases covered include Reactome, NCI-Nature. BioGrid, MINT and more. 

One option is to do graph similarity subgraphs within a large integrated human interaction network. This can be repeated for 3 networks (e.g. NCI-Nature, Reactome and another one).


\item[Graph Similarity] \ \\
Ideas for improving graph similarity
2 types of subgraphs

\begin{itemize}
\item 1 snp = 1 gene subgraphs (e.g. hub snp and targets)
vertex weights: distance of gene to snp

\item 1 cluster = 1 gene subgraph (grab "best gene")
vertex weights: distance of best snp to gene
\end{itemize}

\item[Permutations and Random Graph Generation] 
One option is to take each subgraph, and keep the same nodes and permute the edges 1000 times. This method would investigate the likelihood of finding a higher graph similarity score for a subgraph with the same gene nodes identified, but with different pairings (edges). It would therefore investigate how good the topological similarity of the original graph was against the target graph (pathway). An alternative is to randomly select different nodes (genes) to generate a subgraph with the same vertex count, and edge count. this would also investigate how good the graph similarity was for the subject graph against the target by considering the node identity matches, as well as the topological similarity. 

\end{description}


\newpage
\section{Graph Similarity}

This section defines the graph similarity problem.

\subsection{Weighted Vertex Labeled Graphs}

\tikzstyle{vertex}=[circle,draw,line width=1,fill=black!32,minimum size=30pt,inner sep=0pt]
\tikzstyle{edge} = [draw,thick,-,line width=2pt]

We consider a graph $G = (V,E)$, where $V$ are the vertices and $E$
are the edges. Each vertex $v\in V$ is a tuple $v=(\mbox{name}, w_v)$,
where name comes from a finite set of names, and has a corresponding
positive weight $w_v\in\RR^+$. Each edge $w_e\in E$ is a positive real valued weight
$w_e\in\RR^+$. We call such graphs weighted vertex labeled graphs
(WVLG).

Two examples (Figure~\ref{fig:graph-ex1} and
Figure~\ref{fig:graph-ex2}) are given in Figure~\ref{fig:graph-ex} below.

\begin{figure}[ht]
  \centering
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (b) at (3,0) {(B,0.2)};
      \node[vertex] (c) at (0,-3) {(C,3.5)};
      \node[vertex] (d) at (3,-3) {(D,1.3)};
      \draw[edge] (a) to[bend left] node[above]{1.2} (b);  
      \draw[edge] (a) to[bend right] node[right]{3.1} (d);  
    \end{tikzpicture}
    \caption{First graph}
    \label{fig:graph-ex1}
  \end{subfigure}
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (c) at (3,0) {(C,0.1)};  
      \node[vertex] (d) at (0,-3) {(D,2.1)};  
      \node[vertex] (e) at (3,-3) {(E,0.3)};
      \draw[edge] (a) to[bend left] node[above]{2.2} (c);  
      \draw[edge] (a) to[bend right] node[left]{1.7} (d);  
    \end{tikzpicture}
    \caption{Second graph}
    \label{fig:graph-ex2}
  \end{subfigure}
  \caption{Example weighted vertex labeled graphs, where the set of
    possible names are \{A,B,C,D,E,F,G\}}
  \label{fig:graph-ex}
\end{figure}

\subsection{Biological motivation}

There are several applications in bioinformatics where we would like
to compare two pathways or networks. We briefly outline two
applications below.

\begin{description}
\item[Stability of epistatic interaction]\ \\
  We consider the stability of a
  hypothesis testing approach to find significant pairs of SNPs that
  explain the phenotype in case-control studies. Given a particular
  dataset, we test every pair of features, and obtain a list of
  statistically significant pairs and their scores. To
  test whether the feature selection approach is stable, we compare
  the corresponding list of significant pairs for two datasets for the
  same phenotype. For example different cohorts for a particular
  disease. We compare the two datasets via their corresponding graphs.
  In this case, the vertex names are the SNPs, and the weights are the
  corresponding hypothesis test scores.
\item[Comparing biological pathways]\ \\
  There are several possible approaches to infer pathways of
  biological processes, one example being the case control studies
  described above. Alternative methods include biomedical literature
  mining, protein protein interaction, and microRNA regulation. In
  this case the vertex names are genes and the weights are the
  corresponding confidence in the interaction.
\end{description}

\newpage
\subsection{Intersection and union of two WVLGs}

There are two main operations when intersecting two WVLG:
\begin{enumerate}
\item Set intersection of the vertex names
\item ``Scalar product'' of the corresponding weights to compute the
  cardinality.
\end{enumerate}
Since the vertices are from a finite set, intersecting two graphs
result in subgraphs with common vertices. Furthermore, we only
consider edges which are common to both graphs. See
Figure~\ref{fig:graph-intersect} for the corresponding intersection
graphs to the example. Note that Figure~\ref{fig:graph-intersect2} has
lost the edge between A and C.

\begin{figure}[t]
  \centering
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (c) at (0,-3) {(C,3.5)};
      \node[vertex] (d) at (3,-3) {(D,1.3)};
      \draw[edge] (a) to[bend right] node[right]{3.1} (d);  
    \end{tikzpicture}
    \caption{First graph after intersection}
    \label{fig:graph-intersect1}
  \end{subfigure}
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (c) at (3,0) {(C,0.1)};  
      \node[vertex] (d) at (0,-3) {(D,2.1)};  
      \draw[edge] (a) to[bend right] node[left]{1.7} (d);  
    \end{tikzpicture}
    \caption{Second graph after intersection}
    \label{fig:graph-intersect2}
  \end{subfigure}
  \caption{Intersection graphs corresponding to those in
    Figure~\ref{fig:graph-ex}. The resulting vertex similarity is
    $1.1\times 1.1+3.5\times0.1+1.3\times2.1=4.29$. The edge
    similarity is $3.1\times 1.7=5.27$. The graph similarity is given
    by $(4.29+5.27)/2 = 4.78$.
  }
  \label{fig:graph-intersect}
\end{figure}

However, since the two graphs may have different vertex and edge
weights, the resulting intersection graphs retain their original
weights. To obtain the similarity between these two graphs, we compute
the sum of the products of vertex and edge weights. We take the
average of the vertex and edge sums as the total graph similarity.

An alternative representation would be to represent all vertices and
set weights of ``unobserved'' vertices and edges to zero. Then the
graph similarity would be just the corresponding scalar products.

Similar to the intersection operation, the union consists of
two main operations, illustrated in Figure~\ref{fig:graph-union},
where the set intersection is now the set union.

\begin{figure}[t]
  \centering
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}[scale=0.8]
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (b) at (3,0) {(B,0.2)};
      \node[vertex] (c) at (6,0) {(C,3.5)};
      \node[vertex] (d) at (0,-3) {(D,1.3)};
      \node[vertex] (e) at (3,-3) {(E,0.3)};
      \draw[edge] (a) to[bend right] node[below]{1.2} (b);  
      \draw[edge] (a) to[bend left] node[above]{2.2} (c);  
      \draw[edge] (a) to[bend right] node[right]{3.1} (d);  
    \end{tikzpicture}
    \caption{First graph after union}
    \label{fig:graph-union1}
  \end{subfigure}
  \begin{subfigure}[b]{0.45\textwidth}
    \begin{tikzpicture}[scale=0.8]
      \node[vertex] (a) at (0,0) {(A,1.1)};  
      \node[vertex] (b) at (3,0) {(B,0.2)};
      \node[vertex] (c) at (6,0) {(C,0.1)};  
      \node[vertex] (d) at (0,-3) {(D,2.1)};  
      \node[vertex] (e) at (3,-3) {(E,0.3)};
      \draw[edge] (a) to[bend right] node[below]{1.2} (b);  
      \draw[edge] (a) to[bend left] node[above]{2.2} (c);  
      \draw[edge] (a) to[bend right] node[left]{1.7} (d);  
    \end{tikzpicture}
    \caption{Second graph after union}
    \label{fig:graph-union2}
  \end{subfigure}
  \caption{Union graphs corresponding to those in Figure~\ref{fig:graph-ex}.}
  \label{fig:graph-union}
\end{figure}



\subsection{Extensions}

Here are several potential extensions which are interesting from an
application point of view:
\begin{itemize}
\item Instead of a single weight for each vertex and edge, we have a
  set of weights. This would allow for multiple weights per edge or vertex.
\item Instead of the vertex label being from a finite set, it could be
  an element of a metric space. This would allow ``soft assignment''.
\end{itemize}

\subsection{Statistical significance}

Ideally, a level of significance could be attached to the graph
similarity. A naive approach would be using the empirical data:
\begin{enumerate}
\item Generate random perturbations of known WVLG or directly generate
  WLVGs from some distribution.
\item Compute empirical distributions of the graph similarity.
\item Test whether two graphs are significantly different by
  considering the tail of the empirical distribution.
\end{enumerate}

\end{document}
